{{- if .Values.provisioning.enabled }}
{{- $replicaCount := int .Values.replicaCount }}
kind: Job
apiVersion: batch/v1
metadata:
  name: {{ include "kafka.fullname" . }}-provisioning
  labels: {{- include "common.labels.standard" . | nindent 4 }}
    app.kubernetes.io/component: kafka-provisioning
    {{- if .Values.commonLabels }}
    {{- include "common.tplvalues.render" ( dict "value" .Values.commonLabels "context" $ ) | nindent 4 }}
    {{- end }}
  annotations:
    helm.sh/hook: post-install,post-upgrade
    helm.sh/hook-delete-policy: before-hook-creation
    {{- if .Values.commonAnnotations }}
    {{- include "common.tplvalues.render" ( dict "value" .Values.commonAnnotations "context" $ ) | nindent 4 }}
    {{- end }}
spec:
  template:
    metadata:
      labels: {{- include "common.labels.standard" . | nindent 8 }}
        app.kubernetes.io/component: kafka-provisioning
        {{- if .Values.podLabels }}
        {{- include "common.tplvalues.render" (dict "value" .Values.podLabels "context" $) | nindent 8 }}
        {{- end }}
      annotations:
        {{- if .Values.provisioning.podAnnotations }}
        {{- include "common.tplvalues.render" (dict "value" .Values.provisioning.podAnnotations "context" $) | nindent 8 }}
        {{- end }}
    spec:
      {{- include "kafka.imagePullSecrets" . | nindent 6 }}
      {{- if .Values.provisioning.schedulerName }}
      schedulerName: {{ .Values.provisioning.schedulerName | quote }}
      {{- end }}
      restartPolicy: OnFailure
      terminationGracePeriodSeconds: 0
      initContainers:
        - name: wait-for-available-kafka
          image: {{ include "kafka.image" . }}
          imagePullPolicy: {{ .Values.image.pullPolicy | quote }}
          command:
            - /bin/bash
            - -c
            - >-
              set -e;
              wait-for-port \
                --host={{ include "kafka.fullname" . }} \
                --state=inuse \
                --timeout=120 \
                {{ .Values.service.port | int64 }};
              echo "Kafka is available";
          {{- if .Values.provisioning.resources }}
          resources: {{- toYaml .Values.provisioning.resources | nindent 12 }}
          {{- end }}
      containers:
        - name: kafka-provisioning
          image: {{ include "kafka.image" . }}
          imagePullPolicy: {{ .Values.image.pullPolicy | quote }}
          {{- if .Values.diagnosticMode.enabled }}
          command: {{- include "common.tplvalues.render" (dict "value" .Values.diagnosticMode.command "context" $) | nindent 12 }}
          {{- else }}
          command:
            {{- if .Values.provisioning.command }}
            {{- include "common.tplvalues.render" (dict "value" .Values.provisioning.command "context" $) | nindent 12 }}
            {{- else }}
            - /bin/bash
            {{- end }}
          {{- end }}
          {{- if .Values.diagnosticMode.enabled }}
          args: {{- include "common.tplvalues.render" (dict "value" .Values.diagnosticMode.args "context" $) | nindent 12 }}
          {{- else }}
          args:
            {{- if .Values.provisioning.args }}
            {{- include "common.tplvalues.render" (dict "value" .Values.provisioning.args "context" $) | nindent 12 }}
            {{- else }}
            - -ec
            - |
              {{- $bootstrapServer := printf "%s:%d" (include "kafka.fullname" .) (.Values.service.port | int64) }}
              {{- range $topic := .Values.provisioning.topics }}
              echo "Ensure topic '{{ $topic.name }}' exists"
              /opt/bitnami/kafka/bin/kafka-topics.sh \
                --create \
                --if-not-exists \
                --bootstrap-server {{ $bootstrapServer }} \
                --replication-factor {{ $topic.replicationFactor | default $.Values.provisioning.replicationFactor }} \
                --partitions {{ $topic.partitions | default $.Values.provisioning.numPartitions }} \
                {{- range $name, $value := $topic.config }}
                --config {{ $name }}={{ $value }} \
                {{- end }}
                --topic {{ $topic.name }} &
              {{- end }}
              wait
              {{- range $entity := .Values.provisioning.configOverride }}
              echo "Ensure config on '{{ $entity.name }}' for topic: '{{ $entity.configKey }}={{ $entity.configValue }}'"
              /opt/bitnami/kafka/bin/kafka-configs.sh \
                --alter \
                --entity-type topics \
                --bootstrap-server {{ $bootstrapServer }} \
                --add-config {{ $entity.configKey }}={{ $entity.configValue }} \
                --entity-name {{ $entity.name }} &
              {{- end }}
              {{- if .Values.provisioning.configOverride | empty | not }}
              wait
              {{- end }}
              echo "Provisioning succeeded"
            {{- end }}
          {{- end }}
          env:
            - name: BITNAMI_DEBUG
              value: {{ ternary "true" "false" (or .Values.image.debug .Values.diagnosticMode.enabled) | quote }}
          {{- if .Values.provisioning.resources }}
          resources: {{- toYaml .Values.provisioning.resources | nindent 12 }}
          {{- end }}
          volumeMounts:
            {{- if or .Values.config .Values.existingConfigmap }}
            - name: kafka-config
              mountPath: {{ .Values.persistence.mountPath }}/config/server.properties
              subPath: server.properties
            {{- end }}
            {{- if or .Values.log4j .Values.existingLog4jConfigMap }}
            - name: log4j-config
              mountPath: {{ .Values.persistence.mountPath }}/config/log4j.properties
              subPath: log4j.properties
            {{- end }}
            {{- if (include "kafka.tlsEncryption" .) }}
            {{- if not (empty .Values.auth.tls.existingSecrets) }}
            {{- range $index := .Values.auth.tls.existingSecrets }}
            - name: kafka-certs-{{ $index }}
              mountPath: /certs-{{ $index }}
              readOnly: true
            {{- end }}
            {{- else if or (not (empty (coalesce .Values.auth.tls.existingSecret .Values.auth.jksSecret))) (.Files.Glob "files/tls/*.{crt,pem}") }}
            - name: kafka-certs
              mountPath: /certs
              readOnly: true
            {{- else if .Values.auth.tls.autoGenerated }}
            {{- range $index := until $replicaCount }}
            - name: kafka-certs-{{ $index }}
              mountPath: /certs-{{ $index }}
              readOnly: true
            {{- end }}
            {{- end }}
            {{- end }}
      volumes:
        {{- if or .Values.config .Values.existingConfigmap }}
        - name: kafka-config
          configMap:
            name: {{ include "kafka.configmapName" . }}
        {{- end }}
        {{- if or .Values.log4j .Values.existingLog4jConfigMap }}
        - name: log4j-config
          configMap:
            name: {{ include "kafka.log4j.configMapName" . }}
        {{ end }}
        {{- if (include "kafka.tlsEncryption" .) }}
        {{- if not (empty .Values.auth.tls.existingSecrets) }}
        {{- range $index, $secret := .Values.auth.tls.existingSecrets }}
        - name: kafka-certs-{{ $index }}
          secret:
            secretName: {{ tpl $secret $ }}
            defaultMode: 256
        {{- end }}
        {{- else if or (not (empty (coalesce .Values.auth.tls.existingSecret .Values.auth.jksSecret))) (.Files.Glob "files/tls/*.{crt,pem}") }}
        - name: kafka-certs
          secret:
            secretName: {{ if not (empty (coalesce .Values.auth.tls.existingSecret .Values.auth.jksSecret)) }}{{ tpl (coalesce .Values.auth.tls.existingSecret .Values.auth.jksSecret) . }}{{ else }}{{ printf "%s-tls" (include "kafka.fullname" .) }}{{ end }}
            defaultMode: 256
        {{- else if .Values.auth.tls.autoGenerated }}
        {{- range $index := until $replicaCount }}
        - name: kafka-certs-{{ $index }}
          secret:
            secretName: {{ printf "%s-%d-tls" (include "kafka.fullname" $) $index }}
            defaultMode: 256
        {{- end }}
        {{- end }}
        {{- end }}
{{- end }}
